function menuDatasetTransform(hObject, eventdata, handles, mode)
% function menuDatasetTransform(hObject, eventdata, handles)
% a callback to Menu->Dataset->Transform...
% do different transformation with the dataset
%
% Parameters:
% hObject: handle to im_browser.m (see GCBO)
% eventdata: eventdata structure 
% handles: structure with handles of im_browser.m

% Copyright (C) 14.05.2014, Ilya Belevich, University of Helsinki (ilya.belevich @ helsinki.fi)
% part of Microscopy Image Browser, http:\\mib.helsinki.fi 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
%
% Updates
% 


switch mode
    case {'flipH', 'flipV','flipZ'}
        handles = ib_flipDataset(handles, mode);
    case {'rot90', 'rot-90'}
        handles = ib_rotateDataset(handles, mode);
    case {'xy2zx', 'xy2zy','zx2zy'}
        handles = ib_transposeDataset(handles, mode);
end

handles = handles.Img{handles.Id}.I.updateAxesLimits(handles, 'resize');
% update widgets in the im_browser GUI
handles = updateGuiWidgets(handles);
handles.Img{handles.Id}.I.plotImage(handles.imageAxes, handles, 1);
end