% --- Executes on button press in selectionClearBtn.
function selectionClearBtn_Callback(hObject, eventdata, handles, sel_switch)
% function selectionClearBtn_Callback(hObject, eventdata, handles,sel_switch)
% a callback to the handles.selectionClearBtn, allows to clear the Selection layer
%
% Parameters:
% hObject: handle to im_browser.m (see GCBO)
% eventdata: eventdata structure 
% handles: structure with handles of im_browser.m
% sel_switch: a string to define whether the selection should be cleared
% for the current slice only: 'current'

% Copyright (C) 14.05.2014, Ilya Belevich, University of Helsinki (ilya.belevich @ helsinki.fi)
% part of Microscopy Image Browser, http:\\mib.helsinki.fi 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
%
% Updates
% 


% clear the Selection layer

% do nothing is selection is disabled
if strcmp(handles.preferences.disableSelection, 'yes'); return; end;

modifier = get(handles.im_browser,'currentModifier');
if isempty(modifier)
    sel_switch = 'current';
else
    sel_switch = 'all';
end

if strcmp(sel_switch,'current')
    ib_do_backup(handles, 'selection', 0);
    handles.Img{handles.Id}.I.clearSelection(handles.Img{handles.Id}.I.slices(1,1):handles.Img{handles.Id}.I.slices(1,2),handles.Img{handles.Id}.I.slices(2,1):handles.Img{handles.Id}.I.slices(2,2),handles.Img{handles.Id}.I.slices(4,1):handles.Img{handles.Id}.I.slices(4,2));
else
    ib_do_backup(handles, 'selection', 1);
    handles.Img{handles.Id}.I.clearSelection();
end
handles.Img{handles.Id}.I.plotImage(handles.imageAxes, handles, 0);
end