function selectionErBtn_Callback(hObject, eventdata, handles, sel_switch)
% function selectionErBtn_Callback(~, ~, handles,sel_switch)
% a callback to the handles.selectionErBtn, shrinks the selection layer
%
% Parameters:
% hObject: handle to im_browser.m (see GCBO)
% eventdata: eventdata structure 
% handles: structure with handles of im_browser.m
% sel_switch: [@em optional] a string that defines whether the current
% slice: 'current' or all slices 'all' should be eroded

% Copyright (C) 14.05.2014, Ilya Belevich, University of Helsinki (ilya.belevich @ helsinki.fi)
% part of Microscopy Image Browser, http:\\mib.helsinki.fi 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
%
% Updates
% 


if nargin < 4
    modifier = get(handles.im_browser,'currentModifier');
    if isempty(modifier)
        sel_switch = 'current';
    else
        sel_switch = 'all';
    end
end
% Erode the selection layer in 2d or 3d
handles = ib_erodeSelection(handles, sel_switch);
handles.Img{handles.Id}.I.plotImage(handles.imageAxes, handles, 0);
end